////////////////////////////////////////////////////////////////////////

BOOL CALLBACK ConfirmDialog(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static WaitCount;

	static HWND PasswordBitStatus;
	static HWND PasswordBits_hWnd;
	static HWND PasswordEdit_hWnd;
	static HWND InfoTextStatic_hWnd;

	float PasswordLen = 0;
	float PasswordBits = 0;
	float EffeciencyBits = 0;

	char LocalTemp[257];

	for(;;)
	{
		//---------------------------------------------------------------------------------------------------------

		if(Msg==WM_INITDIALOG)
		{
			ConfirmDialog_hWnd = hDlg;

			//---------------------------------------------------------------------------------------------------------

			/* Set Window Icon And Caption */
			SendMessage(ConfirmDialog_hWnd, WM_SETICON, TRUE,(LPARAM)LoadIcon(GetWindowInstance(ConfirmDialog_hWnd), MAKEINTRESOURCE(1)));
			SendMessage(ConfirmDialog_hWnd, WM_SETTEXT, FALSE,(LPARAM)TitleCaption);

			CenterWindow(ConfirmDialog_hWnd);
			//---------------------------------------------------------------------------------------------------------

			/* Get Dialog Item Handles */
			InfoTextStatic_hWnd = GetDlgItem(ConfirmDialog_hWnd,1000);
			PasswordEdit_hWnd = GetDlgItem(ConfirmDialog_hWnd,2000);
			PasswordBitStatus = GetDlgItem(ConfirmDialog_hWnd,3000);
			PasswordBits_hWnd = GetDlgItem(ConfirmDialog_hWnd,4000);

			//---------------------------------------------------------------------------------------------------------

			if(Encrypt)SetText(InfoTextStatic_hWnd,"Confirm The Password To Be Used To Encrypt This Data");
			if(Pack)SetText(InfoTextStatic_hWnd,"Confirm The Password To Be Used To Pack This Data.");

			//---------------------------------------------------------------------------------------------------------

			break;
		}

		//---------------------------------------------------------------------------------------------------------

		if(Msg == 307) // Key Down
		{
			PasswordLen = (float)SendMessage(PasswordEdit_hWnd, WM_GETTEXTLENGTH,0,0);

			if(PasswordLen >= 8)EnableWindow(GetDlgItem(ConfirmDialog_hWnd,100),TRUE);
			if(PasswordLen <  8)EnableWindow(GetDlgItem(ConfirmDialog_hWnd,100),FALSE);

			if(Encrypt || Pack)
			{
				EffeciencyBits = (PasswordLen / 56) * 100;
				SendMessage(PasswordBitStatus, PBM_SETPOS,(unsigned int)EffeciencyBits,0);

				PasswordBits = (PasswordLen * 8); /* 8-Bits Per Char */
				sprintf(LocalTemp,"(%.0f Bits)",PasswordBits);
				SetText(PasswordBits_hWnd,LocalTemp);
			}
		}

		//---------------------------------------------------------------------------------------------------------

		/* Received A Command Through The Dialog */
		if(Msg == WM_COMMAND)
		{
			//---------------------------------------------------------------------------------------------------------

			if(wParam == 100) // Ok (Button)
			{
				char *InputKey = GetText(PasswordEdit_hWnd);

				if(strlen(InputKey) > 56)
				{
					MessageBox(ConfirmDialog_hWnd,"Key cannot be more than 448-Bits (56 Characters)", TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
					break;
				}

				if(strcmp(InputKey,CodedKey) == 0 )
				{
					EnableWindow(GetDlgItem(ConfirmDialog_hWnd,100),FALSE);
					EnableWindow(PasswordEdit_hWnd,FALSE);

					CodedKey = GetText(PasswordEdit_hWnd);
					EndDialog(ConfirmDialog_hWnd,0);

					break;
				}

				MessageBox(ConfirmDialog_hWnd,"The Passwords Entered Do Not Match.", TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);

				SetFocus(PasswordEdit_hWnd);
			}

			//---------------------------------------------------------------------------------------------------------

			if(wParam == 300) //Cancel (Button)
			{
				CleanUp(0,1);
				CancelFlag = TRUE;
				EndDialog(ConfirmDialog_hWnd,0);
			}

			//---------------------------------------------------------------------------------------------------------

			if(wParam==200) //About (Button)
			{
				ShowWindow(ConfirmDialog_hWnd,FALSE);
				DialogBox(hInstance,MAKEINTRESOURCE(1000),ConfirmDialog_hWnd,AboutDialog);
				ShowWindow(ConfirmDialog_hWnd,TRUE);
				SetFocus(PasswordEdit_hWnd);
			}

			//---------------------------------------------------------------------------------------------------------

			break;
		}

		//---------------------------------------------------------------------------------------------------------

		if(Msg == WM_CLOSE) //Close Dialog
		{
			CleanUp(0,1);
			EndDialog(ConfirmDialog_hWnd,0);
		}

		//---------------------------------------------------------------------------------------------------------

		break;
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////

