////////////////////////////////////////////////////////////////////////////////////////
void DoExit(void)
{
	SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
	EnableWindow(GetDlgItem(MainDialog_hWnd,300),TRUE);
	Done = TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////

void DoCancel(void)
{
	SetText(StatusText_hWnd,"Canceled...");
	SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
	EnableWindow(GetDlgItem(MainDialog_hWnd,300),TRUE);
	Done = TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////

int InternetGetFile(HINTERNET IN InternetFile, char *DownloadURL, char *FileName, HWND hwndProgress, int StatusTextINT, int ProgressBarINT)
{
	DWORD dwSize;
	DWORD DownloadSize = 0;
	DWORD SizeOfRequest = 4;
	DWORD Bytes = 0;
	DWORD Start;
	DWORD End;
	DWORD Time;

	CHAR szHead[] = "Accept: */*\r\n\r\n";
	VOID *ReadBuffer[BufferSize];
	HINTERNET hConnect;
	FILE *TargetFile;

	SetText(StatusText_hWnd,"Opening Download...");

	if(CancelFlag == TRUE)
	{
		return 2; // Return Cancel Flag
	}

	if( !(hConnect = InternetOpenUrlA(InternetFile,DownloadURL,szHead,lstrlenA(szHead),INTERNET_FLAG_DONT_CACHE|INTERNET_FLAG_PRAGMA_NOCACHE|INTERNET_FLAG_RELOAD,0)))
	{
		SetText(StatusText_hWnd,"Could Not Connect To Remote Server.");
		SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
		return 3; // Return Exit Flag
	}

	if(CancelFlag == TRUE) // Return Cancel Flag
	{
		if(hConnect)CloseHandle(hConnect);
		return 2; // Return Cancel Flag
	}

	if(!(TargetFile = fopen (FileName, "wb")))
	{
		SetText(StatusText_hWnd,"Could Not Create Local File.");
		SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
		return 3; // Return Exit Flag
	}

	if(CancelFlag == TRUE) // Return Cancel Flag
	{
		if(hConnect)CloseHandle(hConnect);
		if(TargetFile)fflush(TargetFile);
		if(TargetFile)fclose(TargetFile);
		return 2; // Return Cancel Flag
	}

	SetText(StatusText_hWnd,"Retreiving File Info...");

	if (!HttpQueryInfo(hConnect, HTTP_QUERY_CONTENT_LENGTH | HTTP_QUERY_FLAG_NUMBER,(LPVOID)&DownloadSize, &SizeOfRequest, NULL))
	{
		DownloadSize = 0;
	}

	if(CancelFlag == TRUE) // Return Cancel Flag
	{
		if(hConnect)CloseHandle(hConnect);
		if(TargetFile)fflush(TargetFile);
		if(TargetFile)fclose(TargetFile);
		return 2; 
	}

	SetText(StatusText_hWnd,"Downloading...");

	Time = 10;
	Start = GetTickCount();

	do
	{
		if(CancelFlag == TRUE)
		{
			if(hConnect)CloseHandle(hConnect);
			if(TargetFile)fflush(TargetFile);
			if(TargetFile)fclose(TargetFile);
			return 2; // Return Cancel Flag
		}

		// Keep coping in 16 KB chunks, while file has any data left.
		// Note: bigger buffer will greatly improve performance.
		if (!InternetReadFile (hConnect, ReadBuffer, BufferSize,  &dwSize) )
		{
			if(TargetFile)fclose(TargetFile);
			SetText(StatusText_hWnd,"Error Receiving Remote File.");
			SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
			return 3; // Return Exit Flag
		}

		if (!dwSize)
			break;	// Condition of dwSize=0 indicate EOF. Stop.
		else
			fwrite(ReadBuffer, sizeof (char), dwSize , TargetFile);

		Bytes += dwSize;

		if(DownloadSize && hwndProgress)
		{
			SendDlgItemMessageA(hwndProgress, ProgressBarINT, WM_USER+2, (Bytes*100)/DownloadSize, 0);
			UpdateWindow(hwndProgress);
		}

		FLOAT fSpeed = 0;
		fSpeed = (float)Bytes;
		fSpeed /= ((float)Time)/1000.0f;
		fSpeed /= 1024.0f;

		if(hwndProgress)
		{
			char Status[260];

			if(DownloadSize == 0)
				sprintf(Status, "%d KB Of ? KB @ %1.1f KB/s", Bytes/1024,fSpeed);
			else
				sprintf(Status, "%d KB Of %d KB @ %1.1f KB/s", Bytes/1024, DownloadSize/1024, fSpeed);

			SetText(GetDlgItem(MainDialog_hWnd,StatusTextINT),Status);
		}

		End = GetTickCount();

		Time = End - Start;

		if(Time == 0)Time = 10;

	}	// do
	while (TRUE);

	if(TargetFile)fflush(TargetFile);
	if(TargetFile)fclose(TargetFile);
	if(hConnect)CloseHandle(hConnect);

	if(CancelFlag == TRUE) // Return Cancel Flag
	{
		return 2; // Return Cancel Flag
	}

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////

int InternetDownloadFile(HWND WindowHandle, int StatusTextINT, int ProgressBarINT, char *DownloadURL, char *FileDestination)
{
	DWORD dwFlags;
	DWORD Result = INTERNET_ERROR_OPEN;

	HINTERNET InternetFile;

	SetText(StatusText_hWnd,"Checking Connection.");
	InternetGetConnectedState(&dwFlags, 0);

	//if(dwFlags & INTERNET_CONNECTION_OFFLINE)
		//return INTERNET_ERROR_OPEN;

	if(CancelFlag == TRUE)return 2; // Return Cancel Flag

	SetText(StatusText_hWnd,"Starting Connection.");

	if(!(dwFlags & INTERNET_CONNECTION_PROXY))
		InternetFile = InternetOpenA(Agent, INTERNET_OPEN_TYPE_PRECONFIG_WITH_NO_AUTOPROXY, NULL, NULL, 0);
	else
		InternetFile = InternetOpenA(Agent, INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);

	if(CancelFlag == TRUE)	
	{
		if(InternetFile)InternetCloseHandle(InternetFile);
		return 2; // Return Cancel Flag
	}

	SetText(StatusText_hWnd,"Opening Connection.");

	if(InternetFile)
	{
		Result = InternetGetFile(InternetFile, DownloadURL, FileDestination, WindowHandle, StatusTextINT, ProgressBarINT);

		if(Result == 2)return 2; // Return Cancel Flag
		if(Result == 3)return 3; // Return Exit Flag

		InternetCloseHandle(InternetFile);

		DWORD FileSize = Get_FileSize(FileDestination);
		if(FileSize < 1)
		{
			SetText(StatusText_hWnd,"Could Not Find File Error.");
			return 3; // Return Exit Flag
		}

	}
	else{
		SetText(StatusText_hWnd,"Error opening remote file...");
		return 3; // Return Exit Flag
	}

	if(CancelFlag == TRUE)	// Return Cancel Flag
	{
		if(InternetFile)InternetCloseHandle(InternetFile);
		return 2; // Return Cancel Flag
	}

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI DownloadThread(LPVOID InputURL)
{
	int Result = 0;

	sprintf(DL.TargetFile,"%s\\%s",Get_TempDirectory(),"_Version.Dat");

	Result = InternetDownloadFile(MainDialog_hWnd, 2000, 3000, (char *)InputURL, DL.TargetFile);
	if(Result == 1){Done = TRUE; DeleteFile(DL.TargetFile); return 1;}
	if(Result == 2){DoCancel();  DeleteFile(DL.TargetFile); return 1;}
	if(Result == 3){DoExit();	 DeleteFile(DL.TargetFile); return 1;}

	SetText(StatusText_hWnd,"Comparing Version Info.");

	Result = ParseInfoData(DL.TargetFile);
	if(Result == 1){Done = TRUE; DeleteFile(DL.TargetFile); return 1;}
	if(Result == 2){DoCancel();  DeleteFile(DL.TargetFile); return 1;}
	if(Result == 3){DoExit();	 DeleteFile(DL.TargetFile); return 1;}


	DeleteFile(DL.TargetFile);

	SetText(StatusText_hWnd,"");

	sprintf(DL.TargetFile,"%s\\%s",Get_TempDirectory(),"_AutoUPD.Exe");

	Result = InternetDownloadFile(MainDialog_hWnd, 2000, 3000, DL.SourceURL, DL.TargetFile);
	if(Result == 1){Done = TRUE; return 1;}
	if(Result == 2){DoCancel();  return 1;}
	if(Result == 3){DoExit();	 return 1;}

	SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");

	ShellExecute(0,"Open",DL.TargetFile,NULL,NULL,SW_SHOWNORMAL);

	EndDialog(MainDialog_hWnd,0);

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////

void ClearReadTemp(void)
{
	int LocalLoop = 0;
	while(LocalLoop != 257)
	{
		DL.ReadTemp[LocalLoop] = '\0';
		LocalLoop++;
	}
}

////////////////////////////////////////////////////////////////////////////////////////

int ParseInfoData(char *SourceFile)
{
	FILE *LocalSource;
	int DataLength = 0;
	int NeededMemory;

	if(CancelFlag == TRUE)	// Return Cancel Flag
	{
		return 2;
	}

	// Open Source File
	if((LocalSource = fopen(SourceFile,"rb")) == NULL){
		if(LocalSource)fclose(LocalSource);
		SetText(StatusText_hWnd,"Local File Read Error.");
		SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
		return 1;
	}

	if(CancelFlag == TRUE)	// Return Cancel Flag
	{
		if(LocalSource)fclose(LocalSource);
		return 2;
	}

	// Get File URL
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),4,LocalSource);
	DataLength = atoi(DL.ReadTemp);
	fseek(LocalSource,1,SEEK_CUR);
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),DataLength,LocalSource);
	NeededMemory = DataLength + 1;
	DL.SourceURL = (char *) calloc(NeededMemory,1);
	sprintf(DL.SourceURL,"%s",DL.ReadTemp);

	fseek(LocalSource,1,SEEK_CUR);

	// Get File Version
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),4,LocalSource);
	DataLength = atoi(DL.ReadTemp);
	fseek(LocalSource,1,SEEK_CUR);
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),DataLength,LocalSource);
	NeededMemory = DataLength + 1;
	DL.Version = (char *) calloc(NeededMemory,1);
	sprintf(DL.Version,"%s",DL.ReadTemp);

	fseek(LocalSource,1,SEEK_CUR);

	// Get File Size
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),4,LocalSource);
	DataLength = atoi(DL.ReadTemp);
	fseek(LocalSource,1,SEEK_CUR);
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),DataLength,LocalSource);
	DL.FileSize = atoi(DL.ReadTemp);

	fseek(LocalSource,1,SEEK_CUR);

	// Get Message
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),4,LocalSource);
	DataLength = atoi(DL.ReadTemp);
	fseek(LocalSource,1,SEEK_CUR);
	ClearReadTemp();
	fread(DL.ReadTemp,sizeof(char),DataLength,LocalSource);
	NeededMemory = DataLength + 1;
	DL.Message = (char *) calloc(NeededMemory,1);
	sprintf(DL.Message,"%s",DL.ReadTemp);

	ClearReadTemp();

	if(LocalSource)fclose(LocalSource);

	if(CancelFlag == TRUE)	// Return Cancel Flag
	{
		return 2;
	}

	char DLVersion[1024];
	unsigned long SizeOfDLVersion = sizeof(DLVersion);

	// Get Current Version
	if(GetStringValue(HKEY_CLASSES_ROOT,VersionKey,"ShortVersion",DLVersion,SizeOfDLVersion))
	{
		if(strcmp(DL.Version,DLVersion) == 0)
		{
			char TempMessage[1024];
			sprintf(TempMessage,"You Have The Most Current Version Of %s.",AppName);
			SetText(StatusText_hWnd,TempMessage);
			SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
			return 1;
		}
		else{
			char TempMessage[1024];
			sprintf(TempMessage,"You have %s %s, Update Reports That %s %s Is Now Available. Would You Like To Download And Install It Now? (%d KBytes).  NOTE : %s",AppName,DLVersion,AppName,DL.Version,DL.FileSize/1024,DL.Message);
			if(MessageBox(MainDialog_hWnd, TempMessage, TitleCaption, 0 + MB_ICONQUESTION + MB_TASKMODAL + MB_YESNO) == IDNO)
			{
				SetText(StatusText_hWnd,"Canceled...");
				SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
				return 1;
			}
		}
	}
	else{
		char TempMessage[1024];
		sprintf(TempMessage,"Your %s Version Could Not Be Determined, Update Reports That %s %s Is Available. Would You Like To Download And Install It Now? (%d KBytes).  NOTE : %s",AppName,AppName,DL.Version,DL.FileSize/1024,DL.Message);
		if(MessageBox(MainDialog_hWnd, TempMessage, TitleCaption, 0 + MB_ICONQUESTION + MB_TASKMODAL + MB_YESNO) == IDNO)
		{
			SetText(StatusText_hWnd,"Canceled...");
			SetText(GetDlgItem(MainDialog_hWnd,300),"Exit");
			return 1;
		}
		MessageBox(MainDialog_hWnd, DL.Message, TitleCaption, 0);
	}

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////
