#define FAccess  6   // Check for read and write permission
#define FRead    4   // Check for read permission
#define FWrite   2   // Check for write permission
#define FExecute 1   // Execute (Ignored)
#define FExist   0   // Check for existence of file

#define BufferSize 512
#define MaxFileSize MegaByte * 1000
#define MegaByte 1048576
#define MaxFiles 50000
#define MaxPackFileSize MegaByte * 100
#define ExecutableEnd 73728
#define TitleCaption "448Delta Self-Extractor"
#define AppVersion "1.0 - Not Revised"

#define FlagLEN 8           // Length Of Encrypt/Pack Flags

#define PACCompress "448CPack"
#define ENCCompress "448CFile"
#define PACFlag     "448Pack~"
#define ENCFlag     "448File~"

//---------------------(Function Prototypes)

int DecryptFile(char *,char *);
int Unpack(char *,char *);
int DecompressDecrypt(char *,char *);
int DecompressUnpack(char *,char *);
int DecodeMain(char *, char *);
int PreCheckFile(char *);
int CopySourceFile(char *, char *);
int UnPackFiles(char *,char *);
int GetDirectory(void);

BOOL FileAccess(char *, short);
BOOL IsDirectory(char *);

char *GetText (HWND);
char *GetTempDirectory(void);

void SetText (HWND, char *);
void CenterWindow (HWND);
void ReportError(char *);
void ClearBuffer(void);
void FreeMemory(void);
void Clear_ReadTemp(void);

DWORD Get_FileSize(char *);

//---------------------(Global Handles)

HINSTANCE hInstance;

HWND MainDialog_hWnd;
HWND AboutDialog_hWnd;
HWND StatusDialog_hWnd;

HWND StatusBar_hWnd;
HWND StatusText_hWnd;
HWND OkCancelButton_hWnd;

//---------------------(Global Flags (BOOL))

BOOL CancelFlag = FALSE;
BOOL DoneFlag = FALSE;

//---------------------(Global Variables)

char SourceFileName[1024];
char *CodedKey;

//---------------------(Dialog Prototypes)

BOOL CALLBACK StatusDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK MainDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AboutDialog(HWND, UINT, WPARAM, LPARAM);

//---------------------(Full Thread Prototypes)

HANDLE UnPack_Thread_Handle;
DWORD UnPack_Thread_ID;
DWORD WINAPI UnPack_Thread(LPVOID data);

//---------------------(Full Global Structures)

struct _Package {
DWORD FileCount;               // Number Fo Files In Package
DWORD FolderCount;             // Number Fo Folders In Package

char Buffer[BufferSize];       // Read Buffer
char *FolderNames[MaxFiles+2]; // Array Of FolderNames For UnpackFiles
char *FileNames[MaxFiles+2];   // Array Of FileNames For UnpackFiles
char ReadTemp[1024];           // Used In UnpackFiles Function
char TargetDir[257];           // Actual Target Directory
};     struct _Package Package;

//--------------------------------------

